# *********************************************************************
# nosql.sh: user interface compatibility wrapper back-end.
#
# Copyright (c) 1998,2009 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# *********************************************************************

# Run the requested command.
case $1 in

  --show-copying)
	cat $NOSQL_INSTALL/doc/COPYING
	exit 1
  ;;
  --show-warranty)
	cat $NOSQL_INSTALL/doc/WARRANTY
	exit 1
  ;;
  --show-version|-V|--version)
	printf 'NoSQL version: '
	head -n 1 $NOSQL_INSTALL/nosql.version
	exit 1
  ;;
  --help|-h)
	nosql getcolumn \
	  NAME DESC < $NOSQL_INSTALL/doc/nosqlcommands.table |
					prtable -l${COLUMNS:-80} -s\|
	exit 0
  ;;

  addcol)		shift; addcolumn "$@" ;;
  col)			shift; getcolumn "$@" ;;
  edit)			shift; edittable "$@" ;;
  join)			shift; jointable "$@" ;;
  rmcol)		shift; notcolumn "$@" ;;
  sort)			shift; sorttable "$@" ;;
  setenv)
	echo "TMPDIR=$TMPDIR;" \
	     "NOSQL_CHARSET=$NOSQL_CHARSET;" \
	     "NOSQL_INSTALL=$NOSQL_INSTALL;" \
	     "SWU_INSTALL=$SWU_INSTALL;" \
	     "PATH=$PATH;" \
	     "export NOSQL_INSTALL SWU_INSTALL PATH TMPDIR NOSQL_CHARSET"
	shift
  ;;
  -*)
	echo nosql: unknown option "'$1'" >&2
	exit 1
  ;;
  *)
	cmd=$1
	shift
	$NOSQL_INSTALL/bin/$cmd "$@"
  ;;
esac

# End of program.
